#include <stdio.h>
#include <stdlib.h>
void colorR(int* a, int* b, long N, long M, long col){
    *b=col;
    if(*(b+1)==0)colorR(a, b+1, N, M, col);
    if(*(b-1)==0)colorR(a, b-1, N, M, col);
    if(*(b+M)==0)colorR(a, b+M, N, M, col);
    if(*(b-M)==0)colorR(a, b-M, N, M, col);
}
void color(long N, long M, long K, long* kx, long* ky){
    long i, j, k, res=0;
    int a[N][M];
    for(i=0; i<N; i++){
        for(j=0; j<M; j++){
            if(i!=0&&i!=N-1&&j!=0&&j!=M-1){
                int t=1;
                for(k=0; k<K&&t; k++){
                    if(i==kx[k]&&j==ky[k])t=0;
                }
                if(t)a[i][j]=0;
                else a[i][j]=-1;
            }
            else a[i][j]=-1;
        }
    }
    int *ptr=&a[1][1];
    for(i=1; i<N; i++){for(j=1; j<M; j++)if(a[i][j]==0){
            colorR(ptr, &a[i][j], N, M, res+1);
            res++;
        }
    }
    printf("%ld", res);
}
int main()
{
    long N, M, K;
    scanf("%ld %ld %ld", &N, &M, &K);
    long kx[K], ky[K];
    long i;
    for(i=0; i<K; i++)scanf("%ld %ld", &kx[i], &ky[i]);
    color(N+2, M+2, K, &kx[0], &ky[0]);
    return 0;
}